#include "xbasic_types.h"
#include "xstatus.h"
#include "xio.h"


#define ADDER_OFFSET (0x00000000)
//Gateways In

#define adder_Op1_OFFSET (ADDER_OFFSET+0x0)
//tag name: in_0
//arith_type = Unsigned
//num_bits = 32
//bin_pt = 0
#define adder_Op2_OFFSET (ADDER_OFFSET+0x4)
//tag name: in_1
//arith_type = Unsigned
//num_bits = 32
//bin_pt = 0

//Gateways Out

#define adder_Sum_OFFSET (ADDER_OFFSET+0x8)
//tag name: out_2


#define adder_WriteReg(BaseAddress, RegOffset, Data) \
	XIo_Out32((BaseAddress) + (RegOffset), (Xuint32)(Data))

#define adder_ReadReg(BaseAddress, RegOffset) \
	XIo_In32((BaseAddress) + (RegOffset))

//Write Reg Macro

#define adder_WriteReg_Op1(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (adder_Op1_OFFSET), (Xuint32)(Value))
#define adder_WriteReg_Op2(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (adder_Op2_OFFSET), (Xuint32)(Value))
#define adder_WriteReg_Sum(BaseAddress, Value) \
	XIo_Out32((BaseAddress) + (adder_Sum_OFFSET), (Xuint32)(Value))


//Read Reg Macro

#define adder_ReadReg_Op1(BaseAddress) \
	XIo_In32((BaseAddress) + (adder_Op1_OFFSET))
#define adder_ReadReg_Op2(BaseAddress) \
	XIo_In32((BaseAddress) + (adder_Op2_OFFSET))
#define adder_ReadReg_Sum(BaseAddress) \
	XIo_In32((BaseAddress) + (adder_Sum_OFFSET))
